#include <cstring>
#include <cstdlib>
#include <cstdio>

#include "myspell.hxx"
#include "config.hxx"

#ifndef WINDOWS
using namespace std;
#endif

#ifdef EXT_CLASS
#define FLAG_LEN 2
#else
#define FLAG_LEN 1
#endif

int main(int argc, char **argv)
{
#ifdef HUNMORPH
    FILE *wtclst;
    int i;
    int dp;
    char buf[101];
    MySpell *pMS;
	char * p;

    /* first parse the command line options */

    for (i = 1; i < 3; i++)
	if (!argv[i]) {
	    fprintf(stderr, "correct syntax is:\nexample affix_file");
	    fprintf(stderr, "dictionary_file file_of_words_to_check\n");
	    exit(1);
	}

    /* open the words to check list */

    wtclst = fopen(argv[3], "r");
    if (!wtclst) {
	fprintf(stderr, "Error - could not open file to check\n");
	exit(1);
    }

    pMS = new MySpell(argv[1], argv[2]);
	while (fgets(buf, 100, wtclst)) {
		*(buf + strlen(buf) - 1) = '\0';
		dp = pMS->spell(buf);
    	fprintf(stdout, "> %s\n", buf);
		if (dp) {
			p = pMS->morph(buf);
            if (p) {
				fprintf(stdout, "%s\n", p);
				free(p);
			}
		} else {
			p = pMS->morph_with_correction(buf);
            if (p) {
	        	fprintf(stdout, "Spelling error. Suggestion:\n");
				fprintf(stdout, "%s\n", p);
				free(p);
			} else {
				p = pMS->morph(buf);
            	if (p) {
	        		fprintf(stdout, "Spelling error, but:\n");
					fprintf(stdout, "%s\n", p);
					free(p);
				} else {
	        		fprintf(stdout, "Unknown word.\n");
				}			
			}
    	}
   	}
    //delete pMS;
    return 0;
#else
	printf("Compiling hunmorph.cxx set HUNMORPH macro in config.hxx\n");
#endif
	
}
