/*************************************************************************
* (C) 2002 Noll Janos <spdaemon@johnzero.hu>, Prim Kft.
*    license: GNU GPL
*
*************************************************************************/

#include <cstring>
#include <cstdlib>
#include <cstdio>

#include <set>
#include <string>
#include <map>

#include <locale.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>

#include "myspell.hxx"

int spcheck_init( char *datadir, char *lcodes );
char *spcheck_process( char *reqstart, char *reqend );
int spcheck_end( void );

extern char * mystrdup(const char * s);

/********************************************************************/

using namespace std;

struct ltstr
{
 bool operator()(string s1, string s2) const {
    return s1 < s2;
 }
};

static map<string,MySpell *,ltstr> mpmap;

static int debug=1;

char *replybuf=NULL;
int replybufsize=0;

int instnum=0;

//--------------------------------------------------

int spcheck_init( char *datadir, char *lcodes ) 
{
 char af[300],df[300];
 char *lclist;
 char *lcode,*ddir;
 char *wtc;
 FILE *wtclst;

 lclist = mystrdup(lcodes);

 lcode=strtok(lclist,",");
 while (lcode) {
    if (debug) printf("Lcode: %s\n",lcode);
    snprintf(af,299,"%s/%s.aff",datadir,lcode);
    snprintf(df,299,"%s/%s.dic",datadir,lcode);
    if (debug) printf(" files: %s,%s\n",af,df);

    MySpell *pMS = new MySpell(af,df);
    mpmap[string(lcode)]=pMS;
    if (debug) printf(" loaded.\n");

    lcode=strtok(NULL,",");
 }
 
 free(lclist);

 return 0;
}



char *spcheck_process( char *reqstart, char *reqend )
{
 char * wtc;
 FILE* wtclst;
 char lcode[10];

 //if (debug) printf("Spcheck: Lcode: %s\n",lcode);

/* strcpy(lcode,"hu_HU");
 setlocale(LC_ALL,lcode);

 MySpell *pMS = mpmap[lcode];
*/

 MySpell *pMS = NULL;
 
 set<string> szolista;


 /*
 if (instnum++>20) {
    instnum=0;
    delete(pMS);
    pMS = new MySpell("./hu_HU.aff","./hu_HU.dic");
    mpmap[string(lcode)]=pMS;
 }
 */

 string rets;
    
 int len;
 int dp;
 char *buf,buf2[100+1],buf3[100+1];
 char *bufp;
 char *ps,*pe,*plast,*p,*q;
 int state=0;

 bufp=reqstart;
 while(bufp<reqend) {
    /* read next line - set buf to line */
    buf=bufp;
    p=strchr(bufp,'\n');
    if (!p) { p=reqend-1; }
    bufp=p+1;
    *p='\0';

    if (state==0) {
        if (buf[0]=='>') {
	    state=1;
	} else {
	    strcpy(lcode,buf);
	    pMS = mpmap[lcode];
	    /* what to do if locale doesn't exist?? error! ? */

	    setlocale(LC_ALL,lcode);
	}
        continue;
    }
          
    if (state==1) {
        if (buf[0]=='>') {
	    state=2;
	} else {
	    for (p=buf;*p;p++) *p=toupper(*p);
	    //printf("-> %s\n",buf);
	    szolista.insert(buf);
	}
        continue;
    }
    
	ps=pe=plast=buf;
	while ( ps < bufp ) {  
	    if (isspace(*pe) || ispunct(*pe) || (pe>=(bufp-1)) ) {
		len=pe-ps;
	
		// mindig csak 1 kar-t kell max kirakni!
		if (ps-plast) {
		    buf2[0]='\\';
		    buf2[1]=*plast;
		    buf2[2]=0;
		    if (*plast=='>' || *plast=='<' || *plast=='|' || *plast=='\\')
	    		rets+=buf2;
		    else 
    		        rets+=(buf2+1);
		}
		
		if (len>2) {
		    if (len>100) len=100;

		    strncpy(buf2,ps,len);
		    buf2[len]=0;
		    //printf("[%s]\n",buf2);

	    	    dp = pMS->spell(buf2);
		    if (dp) {
			// rendben a szo
			rets+=buf2;
		    } else {
			//set<char *>::iterator it;
			for (p=buf2,q=buf3;*p;p++,q++) *q=toupper(*p);
			*q=0;
			
			if (szolista.find(buf3)!=szolista.end()) {
			    //fputs("->",stdout);
			    rets+=buf2;
			} else {
			    /*	rets+="<";
				rets+=buf2;
				rets+=">";
			    */
			
			    char ** wlst;
			    int ns = pMS->suggest(&wlst,buf2);
			    if (ns==0) {
				// ha nincs javaslat
				rets+="<";
				rets+=buf2;
				rets+=">";
			    } else {
				// ha vannak javaslatok
			        rets+="<";
				rets+=buf2;
				rets+="|";
			        for (int i=0; i < ns; i++) {
				    if (i) rets+="|";
		        	    rets+=wlst[i];
			    
		        	    free(wlst[i]);
				}
				rets+=">";
			    }
			    free(wlst);
			}
	    	    }
		} else {
		    if (len>0) {
			strncpy(buf2,ps,len);
			buf2[len]=0;
		        rets+=buf2;
		    }
		}
		plast=pe;
		ps=pe+1;
	    }
	    pe++;
	}

	// mindig csak 1 kar-t kell max kirakni!
	if (ps-plast) {
	    buf2[0]='\\';
	    buf2[1]=*plast;
	    buf2[2]=0;
	    if (*plast=='>' || *plast=='<' || *plast=='|' || *plast=='\\')
    		rets+=buf2;
	    else 
	        rets+=(buf2+1);
	}
	
        rets+="\n";
 }

 p=(char *)rets.c_str();
 len=rets.size();
 if ((len+1)>replybufsize) {
     if (replybuf) free(replybuf);
     replybuf=(char *)malloc(len+1);
     replybufsize=len+1;
 }
 strcpy(replybuf,p);

 return(replybuf);
}

int spcheck_end( void ) {
 if (replybuf) free(replybuf);

 return 0;
}
