#ifndef _SUGGESTMGR_HXX_
#define _SUGGESTMGR_HXX_

#define MAXSWL 100
#define MAXACCENT 5

#include "atypes.hxx"
#include "affixmgr.hxx"

class SuggestMgr
{
  char *          ctry;
  int             ctryl;
  AffixMgr*       pAMgr;
  int             maxSug;
  int		  cpdsuggest; // XXX not stateless
  int checknum;
  struct cs_info * csconv;
    
 
public:
  SuggestMgr(const char * tryme, int maxn, AffixMgr *aptr);
  ~SuggestMgr();

  int suggest(char*** slst, const char * word, int nsug);
  int suggest_auto(char*** slst, const char * word, int nsug);
  int suggest_stems(char*** slst, const char * word, int nsug);
  int suggest_pos_stems(char*** slst, const char * word, int nsug);
  int check(const char *, int);
  int check_forbidden(const char *, int);

  char * suggest_morph(const char * word);
  char * suggest_morph_for_spelling_error(const char * word);

private:
   int replchars(char**, const char *, int);
   int doubledsyllable(char**, const char *, int);
   int permuteaccent(char **, char *, int, int, int, replentry *, int);
   int forgotaccent(char **, const char *, int);
   int forgotchar(char **, const char *, int);
   int swapchar(char **, const char *, int);
   int extrachar(char **, const char *, int);
   int badchar(char **, const char *, int);
   int twowords(char **, const char *, int);
   int fixstems(char **, const char *, int);
};

#endif

