#include <cstring>
#include <cstdlib>
#include <cstdio>

#include "langid.hxx"
#include "myspell.hxx"

#ifndef WINDOWS
using namespace std;
#endif

/*
 *  testlangid - language detection by line
 */

int main(int argc, char **argv)
{
    FILE *wtclst;
    int i;
    char buf[MAXLNLEN];
    char * filename;
    char * dicpath;
    LangId *pLI;

    /* first parse the command line options */

    for (i = 1; i < 3; i++)
	if (!argv[i]) {
	    fprintf(stderr, "correct syntax is:\ntestlangid dictinary.lst [dict_path] file\n");
	    exit(1);
	}

    /* open the words to check list */
    if (argc == 4) {
        dicpath = argv[2];
        filename = argv[3];
    } else {
        dicpath = "./";
        filename = argv[2];
    }

    wtclst = fopen(filename, "r");
    if (!wtclst) {
	fprintf(stderr, "Error - could not open file to language detection\n");
	exit(1);
    }

    //fprintf(stderr, "%s:%s", filename, dicpath);
    pLI = new LangId(argv[1], dicpath);

    while (fgets(buf, 100, wtclst)) {
        char ** list;
        int n = pLI->identify_data(&list, buf, strlen(buf));
        for (i = 0; i < n; i++) {
    	    fprintf(stdout, "%s ", list[i]);
            free(list[i]);
        }
        fprintf(stdout,"\n");
        free(list);
    }

    delete pLI;    
    return 0;
}
